/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg.quotegenerator;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;
import org.telegram.telegrambots.meta.api.methods.send.SendMessage;
import org.telegram.telegrambots.meta.exceptions.TelegramApiException;

/**
 *
 * @author omozegieaziegbe
 */
@Service
public class QuoteGeneratorTelegramBot {

    private final TelegramBot telegramBot;
    private final QuoteService quoteGenerator;
    

    @Autowired
    public QuoteGeneratorTelegramBot(TelegramBot telegramBot, QuoteService quoteGenerator) {
        this.telegramBot = telegramBot;
        this.quoteGenerator = quoteGenerator;
    }

    // Scheduled task that sends random quotes at fixed intervals
    @Scheduled(fixedRate = 60000) // Adjust the interval as needed (e.g., 60000 ms = 1 minute)
    public void sendScheduledQuote() {

        // Get a random quote from the generator
        String randomQuote = quoteGenerator.getRandomQuote();

        // The chat ID where you want to send the quote
        long chatId = telegramBot.getChatId(); 

        try {
            telegramBot.execute(new SendMessage(String.valueOf(chatId), randomQuote));
        } catch (TelegramApiException e) {
            e.printStackTrace();
        }
    }
}
